﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Runtime.InteropServices;
using System.Diagnostics;
using System.Threading;

namespace comserver
{
    [ComVisible(true)]
    [Guid("c7452557-b191-3d04-bbba-cf90fa7c7141")]
    [InterfaceType(ComInterfaceType.InterfaceIsIUnknown)]
    public interface IHehServerEvents
    {
        void FireEvent();
    }

    [ComVisible(true)]
    [Guid("05fe466f-d00f-39bf-b4a0-04fb53438a4a")]
    [InterfaceType(ComInterfaceType.InterfaceIsIUnknown)]
    public interface IHehServer
    {
        void TriggerEventOnThisThread();
        void AddEvent(IHehServerEvents evt);
    }

    [ComVisible(true)]
    [Guid("c9f685ea-3388-3ff5-958a-3234d08587c1")]
    [ClassInterface(ClassInterfaceType.None)]
    public class HehServer : IHehServer
    {
        Thread thCall;

        public HehServer()
        {
            thCall = new Thread(threadFunc);
            thCall.Start();
        }

        void threadFunc()
        {
            while (true)
            {
                TriggerAllEvent();
                Thread.Sleep(1000);
            }
        }

        void TriggerAllEvent()
        {
            foreach (IHehServerEvents evt in m_listeners)
            {
                evt.FireEvent();
            }
        }

        public List<IHehServerEvents> m_listeners =
            new List<IHehServerEvents>();

        public void TriggerEventOnThisThread()
        {
            TriggerAllEvent();
        }

        public void AddEvent(IHehServerEvents evt)
        {
            m_listeners.Add(evt);
        }
    }
}
